<?php
class ControllerShippingDhl4You extends Controller {
	private $error = array();

	public function index() {
		$this->load->language('shipping/dhl4you');

		$this->document->setTitle($this->language->get('heading_title'));

		$this->load->model('setting/setting');

		if (($this->request->server['REQUEST_METHOD'] == 'POST') && $this->validate()) {
			$this->model_setting_setting->editSetting('dhl4you', $this->request->post);

			$this->session->data['success'] = $this->language->get('text_success');

			$this->redirect($this->url->link('extension/shipping', 'token=' . $this->session->data['token'], 'SSL'));
		}

		$this->data['heading_title'] = $this->language->get('heading_title');

		$this->data['text_enabled'] = $this->language->get('text_enabled');
		$this->data['text_disabled'] = $this->language->get('text_disabled');
		$this->data['text_all_zones'] = $this->language->get('text_all_zones');
		$this->data['text_none'] = $this->language->get('text_none');

		$this->data['entry_total'] = $this->language->get('entry_total');
		$this->data['text_help_small'] = $this->language->get('text_help_small');
		$this->data['text_help_large'] = $this->language->get('text_help_large');
		$this->data['text_help_germany'] = $this->language->get('text_help_germany');
		$this->data['text_help_europe'] = $this->language->get('text_help_europe');
		$this->data['text_help_world'] = $this->language->get('text_help_world');

		$this->data['text_none'] = $this->language->get('text_none');
		$this->data['text_yes'] = $this->language->get('text_yes');
		$this->data['text_no'] = $this->language->get('text_no');


		$this->data['entry_small_cost'] = $this->language->get('entry_small_cost');
		$this->data['entry_large_cost'] = $this->language->get('entry_large_cost');
		$this->data['entry_germany_cost'] = $this->language->get('entry_germany_cost');
		$this->data['entry_westeurope_cost'] = $this->language->get('entry_westeurope_cost');
		$this->data['entry_europe_cost'] = $this->language->get('entry_europe_cost');
		$this->data['entry_world_cost'] = $this->language->get('entry_world_cost');

		$this->data['entry_use_freeshipping'] = $this->language->get('entry_use_freeshipping');
		$this->data['entry_tax_class'] = $this->language->get('entry_tax_class');
		$this->data['entry_geo_zone'] = $this->language->get('entry_geo_zone');
		$this->data['entry_status'] = $this->language->get('entry_status');
		$this->data['entry_sort_order'] = $this->language->get('entry_sort_order');

		$this->data['button_save'] = $this->language->get('button_save');
		$this->data['button_cancel'] = $this->language->get('button_cancel');

		$this->data['tab_general'] = $this->language->get('tab_general');
		$this->data['tab_netherlands'] = $this->language->get('tab_netherlands');
		$this->data['tab_germany'] = $this->language->get('tab_germany');
		$this->data['tab_europe'] = $this->language->get('tab_europe');
		$this->data['tab_world'] = $this->language->get('tab_world');

		$this->data['text_countries_westeurope'] = $this->language->get('text_countries_westeurope');
		$this->data['text_countries_europe'] = $this->language->get('text_countries_europe');
		$this->data['text_countries_world'] = $this->language->get('text_countries_world');
		$this->data['text_countries_customs'] = $this->language->get('text_countries_customs');


 		if (isset($this->error['warning'])) {
			$this->data['error_warning'] = $this->error['warning'];
		} else {
			$this->data['error_warning'] = '';
		}

  		$this->data['breadcrumbs'] = array();

   		$this->data['breadcrumbs'][] = array(
       		'text'      => $this->language->get('text_home'),
			'href'      => $this->url->link('common/home', 'token=' . $this->session->data['token'], 'SSL'),
      		'separator' => false
   		);

   		$this->data['breadcrumbs'][] = array(
       		'text'      => $this->language->get('text_shipping'),
			'href'      => $this->url->link('extension/shipping', 'token=' . $this->session->data['token'], 'SSL'),
      		'separator' => ' :: '
   		);

   		$this->data['breadcrumbs'][] = array(
       		'text'      => $this->language->get('heading_title'),
			'href'      => $this->url->link('shipping/dhl4you', 'token=' . $this->session->data['token'], 'SSL'),
      		'separator' => ' :: '
   		);

		$this->data['action'] = $this->url->link('shipping/dhl4you', 'token=' . $this->session->data['token'], 'SSL');

		$this->data['cancel'] = $this->url->link('extension/shipping', 'token=' . $this->session->data['token'], 'SSL');

		// Netherlands
		if (isset($this->request->post['dhl4you_small_cost'])) {
			$this->data['dhl4you_small_cost'] = $this->request->post['dhl4you_small_cost'];
		} else {
			$this->data['dhl4you_small_cost'] = $this->config->get('dhl4you_small_cost');
		}

		if (isset($this->request->post['dhl4you_large_cost'])) {
			$this->data['dhl4you_large_cost'] = $this->request->post['dhl4you_large_cost'];
		} else {
			$this->data['dhl4you_large_cost'] = $this->config->get('dhl4you_large_cost');
		}

		// Germany
		if (isset($this->request->post['dhl4you_germany_cost'])) {
			$this->data['dhl4you_germany_cost'] = $this->request->post['dhl4you_germany_cost'];
		} else {
			$this->data['dhl4you_germany_cost'] = $this->config->get('dhl4you_germany_cost');
		}

		// Western Europe - except Germany
		if (isset($this->request->post['dhl4you_westeurope_cost'])) {
			$this->data['dhl4you_westeurope_cost'] = $this->request->post['dhl4you_westeurope_cost'];
		} else {
			$this->data['dhl4you_westeurope_cost'] = $this->config->get('dhl4you_westeurope_cost');
		}

		// Rest of Europe - except Germany
		if (isset($this->request->post['dhl4you_europe_cost'])) {
			$this->data['dhl4you_europe_cost'] = $this->request->post['dhl4you_europe_cost'];
		} else {
			$this->data['dhl4you_europe_cost'] = $this->config->get('dhl4you_europe_cost');
		}

		// Rest of the World
		if (isset($this->request->post['dhl4you_world_cost'])) {
			$this->data['dhl4you_world_cost'] = $this->request->post['dhl4you_world_cost'];
		} else {
			$this->data['dhl4you_world_cost'] = $this->config->get('dhl4you_world_cost');
		}

		// Settings
		if (isset($this->request->post['dhl4you_use_freeshipping'])) {
			$this->data['dhl4you_use_freeshipping'] = $this->request->post['dhl4you_use_freeshipping'];
		} else {
			$this->data['dhl4you_use_freeshipping'] = $this->config->get('dhl4you_use_freeshipping');
		}

		if (isset($this->request->post['dhl4you_total'])) {
			$this->data['dhl4you_total'] = $this->request->post['dhl4you_total'];
		} else {
			$this->data['dhl4you_total'] = $this->config->get('dhl4you_total');
		}

		if (isset($this->request->post['dhl4you_geo_zone_id'])) {
			$this->data['dhl4you_geo_zone_id'] = $this->request->post['dhl4you_geo_zone_id'];
		} else {
			$this->data['dhl4you_geo_zone_id'] = $this->config->get('dhl4you_geo_zone_id');
		}

		if (isset($this->request->post['dhl4you_tax_class_id'])) {
			$this->data['dhl4you_tax_class_id'] = $this->request->post['dhl4you_tax_class_id'];
		} else {
			$this->data['dhl4you_tax_class_id'] = $this->config->get('dhl4you_tax_class_id');
		}

		if (isset($this->request->post['dhl4you_status'])) {
			$this->data['dhl4you_status'] = $this->request->post['dhl4you_status'];
		} else {
			$this->data['dhl4you_status'] = $this->config->get('dhl4you_status');
		}

		if (isset($this->request->post['dhl4you_sort_order'])) {
			$this->data['dhl4you_sort_order'] = $this->request->post['dhl4you_sort_order'];
		} else {
			$this->data['dhl4you_sort_order'] = $this->config->get('dhl4you_sort_order');
		}

		$this->load->model('localisation/tax_class');

		$this->data['tax_classes'] = $this->model_localisation_tax_class->getTaxClasses();

		$this->load->model('localisation/geo_zone');

		$this->data['geo_zones'] = $this->model_localisation_geo_zone->getGeoZones();

		$this->template = 'shipping/dhl4you.tpl';
		$this->children = array(
			'common/header',
			'common/footer'
		);

		$this->response->setOutput($this->render());
	}

	private function validate() {
		if (!$this->user->hasPermission('modify', 'shipping/dhl4you')) {
			$this->error['warning'] = $this->language->get('error_permission');
		}

		if (!$this->error) {
			return true;
		} else {
			return false;
		}
	}
}
?>